<?php

class SilkPayNotifyModuleFrontController extends ModuleFrontController
{
    public function display()
    {
        $notify = file_get_contents('php://input');
        if ($notify) {
            PrestaShopLogger::addLog(json_encode($notify), 1, 400, 'Silkpay');
            $notify = json_decode($notify, true);
            $transactionid = $notify['transactionNumber'];
            //file_put_contents(dirname(__FILE__) . '/' . $transactionid . '.txt', $notify);
            $status = $notify['status'];
            $status_array = ['SUCCESS', 'TRADE_SUCCESS', 'TRADE_FINISHED', 'PAID', 'REFUND'];
            if (in_array($status, $status_array)) {
                $silkpay = new SilkPayClass();
                $row = $silkpay->findRowByTransactionId($transactionid);
                if ($row) {
                    //如果记录存在
                    $id_order = $row['id_cart'];
                    $order = new Order($id_order);
                    if (Validate::isLoadedObject($order)) {
                        if ($status === 'REFUND') {
                            $id_state = Configuration::get('PS_OS_REFUND');
                        } else {
                            $id_state = Configuration::get('PS_OS_PAYMENT');
                        }
                        foreach (OrderPayment::getByOrderReference($order->reference) as $item) {
                            if (strtolower($item->payment_method) === 'silkpay' && !$item->transaction_id) {
                                $item->transaction_id = $transactionid;
                                $item->save();
                            }
                        };
                        if ((int)$order->current_state !== (int)$id_state) {
                            $order->setCurrentState($id_state);
                        }
                    }
                }
            }
        }
    }
}
